#include "CBomb.h"

CBomb::CBomb(CMapAccess* m,CPlayer* p,int x,int y,int pr)
{
	Y1 = 0;
	Y2 = 0;
	Y3 = 0;
	time = BOMB_TIMER;
	power = pr;
	CBomb::x = x;
	CBomb::y = y;
	CBomb::lord = p;
	map =  m;
	anim = 0;
	tAnim = BOMB_ANIM_SPEED;
	Explode = false;
}

CBomb::~CBomb()
{
}

void CBomb::InitFire()
{
	Explode = true;
	anim = 0;
	tAnim = FIRE_ANIM_SPEED;
	CEvent *e2 = new CEvent(eBOMB_EXPLODE_BEGIN,this,lord);
	SendEvent(e2);
}

void CBomb::CheckWallsExplosion()
{
	bool lt = true;	bool rt = true;	bool up = true;	bool dn = true;
	for(int i=1;i<=power;i++)
	{	
		if (rt)
		{
			if (map->checkMapPos(x + i,y)>=3) rt = false;
			if (!rt && map->checkMapPos(x + i,y)<=10) map->setMapPos(x + i,y,MAP_NOWEXP);
		}
		if (lt)
		{
			if (map->checkMapPos(x - i,y)>=3) lt = false;
			if (!lt && map->checkMapPos(x - i,y)<=10) map->setMapPos(x - i,y,MAP_NOWEXP);
		}
		if (up)
		{
			if (map->checkMapPos(x,y - i)>=3) up = false;
			if (!up && map->checkMapPos(x,y - i)<=10) map->setMapPos(x,y - i,MAP_NOWEXP);
		}
		if (dn)
		{
			if (map->checkMapPos(x,y + i)>=3) dn = false;
			if (!dn && map->checkMapPos(x,y + i)<=10) map->setMapPos(x,y + i,MAP_NOWEXP);
		}
	}
}

void CBomb::CheckWallsExplosion2()
{
	for(int i=1;i<=power;i++)
	{	
		if (map->checkMapPos(x + i,y) == 15) map->setMapPos(x + i,y,MAP_CLEAR);
		if (map->checkMapPos(x - i,y) == 15) map->setMapPos(x - i,y,MAP_CLEAR);
		if (map->checkMapPos(x,y - i) == 15) map->setMapPos(x,y - i,MAP_CLEAR);
		if (map->checkMapPos(x,y + i) == 15) map->setMapPos(x,y + i,MAP_CLEAR);
	}
}

// 1       
void CBomb::CheckBombExplosion(CBomb *bmb)
{
	int xb = bmb->x;
	int yb = bmb->y;
	int pb = bmb->power;
	bool lt = true;	bool rt = true;	bool up = true;	bool dn = true;
	for(int i=1;i<=pb;i++)
	{	
		if (map->checkMapPos(xb + i,yb)>=3) rt = false;
		if (map->checkMapPos(xb - i,yb)>=3) lt = false;
		if (map->checkMapPos(xb,yb - i)>=3) up = false;
		if (map->checkMapPos(xb,yb + i)>=3) dn = false;
		
		if (dn && (xb == x && yb + i == y))	A1(1);
		if (rt && (xb + i == x && yb == y)) A1(1);
		if (lt && (xb - i == x && yb == y)) A1(1);
		if (up && (xb == x && yb - i == y))	A1(1);
	}
}

bool CBomb::TranslateEvent(CEvent* e)
{
	switch (e->num)
	{
		case eBOMB_EXPLODE_BEGIN:
			if (e->bmb != this)
				CheckBombExplosion(e->bmb);
			else
				CheckWallsExplosion();
			break;
		case eBOMB_EXPLODE_END:
			
			break;
	}
	return true;
}

void CBomb::Paint(int z)
{
	if (!Explode)
	{
		map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,anim);
	}
	else
	{
		bool lt = true;	bool rt = true;	bool up = true;	bool dn = true;
		map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,8 + anim);
		for(int i=1;i<power;i++)
		{
			if (map->checkMapPos(x + i,y)>=3) rt = false;
			if (map->checkMapPos(x - i,y)>=3) lt = false;
			if (map->checkMapPos(x,y + i)>=3) dn = false;
			if (map->checkMapPos(x,y - i)>=3) up = false;
			if (rt && map->checkMapPos(x + i,y) < 3)
				map->addObject(MAP_OFFSET_X + (x + i) * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,12 + anim);
			if (lt && map->checkMapPos(x - i,y) < 3)
				map->addObject(MAP_OFFSET_X + (x - i) * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,12 + anim);
			if (dn && map->checkMapPos(x,y + i) < 3)
				map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + (y + i)* CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,32 + anim);
			if (up && map->checkMapPos(x,y - i) < 3)
				map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + (y - i) * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,32 + anim);

			if (map->checkMapPos(x + i,y) == 15)
				map->addObject(MAP_OFFSET_X + (x + i) * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,16 + anim);
			if (map->checkMapPos(x - i,y) == 15)
				map->addObject(MAP_OFFSET_X + (x - i) * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,16 + anim);
			if (map->checkMapPos(x,y + i) == 15)
				map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + (y + i) * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,16 + anim);
			if (map->checkMapPos(x,y - i) == 15)
				map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + (y - i) * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,16 + anim);
		}
		if (up && map->checkMapPos(x,y - power) < 3)
			map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + (y - power) * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + power + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,28 + anim);
		if (dn && map->checkMapPos(x,y + power) < 3)
			map->addObject(MAP_OFFSET_X + x * CELL_SIZE,MAP_OFFSET_Y + (y + power) * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + power + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,4 + anim);
		if (rt && map->checkMapPos(x + power,y) < 3)
			map->addObject(MAP_OFFSET_X + (x + power) * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + power + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,24 + anim);
		if (lt && map->checkMapPos(x - power,y) < 3)
			map->addObject(MAP_OFFSET_X + (x - power) * CELL_SIZE,MAP_OFFSET_Y + y * CELL_SIZE,2 * MAX_BOMBS_ON_MAP + power + MAX_PLAYERS + z + 1,CELL_SIZE,CELL_SIZE,1,20 + anim);
	}
}

void CBomb::You()
{
	A1(0);
}






