#include "CMapAccess.h"
#include "defines.h"

CMapAccess::CMapAccess(CMap* m)
{
	map = m;
}

CMapAccess::~CMapAccess()
{

}

int CMapAccess::checkMapPos(int x, int y)
{
	if (x>=0 && y>=0 && x<MAP_WIDTH && y<MAP_HEIGHT)
	{
	switch (map->getMapPos(x,y))
	{
		case MAP_WALL1:
			return 11;
		case MAP_WALL2:
			return 3;
		case MAP_WALL3:
			return 4;
		case MAP_WALL4:
			return 5;
		case MAP_WALL5:
			return 6;
		case MAP_WALL6:
			return 7;
		case MAP_WALL7:
			return 8;
		case MAP_WALL8:
			return 9;
		case MAP_BOMB:
			return 1;
		case MAP_CLEAR:
			return 0;
		case MAP_NOWEXP:
			return 15;
		default:
			return -1;
	}
	} else return 10000;
}

bool CMapAccess::getObject(int n,int& x,int& y,int& w,int& h,int& t,int& d)
{	
	LPSObject o = map->getObject(n);
	if (o != 0) 
	{
		x = o->x;
		y = o->y;
		w = o->width;
		h = o->height;
		t = o->type;
		d = o->data;
		map->deleteObject(n);
		return true;		
	}
	return false;
}

void CMapAccess::addObject(int x,int y,int z,int w,int h,int t,int data)
{
	map->AddObject(x,y,z,w,h,t,data);
}

void CMapAccess::setMapPos(int x,int y,int d)
{
	if (x>=0 && y>=0 && x<MAP_WIDTH && y<MAP_HEIGHT)
	{
		map->setMapPos(x,y,d);
	}
}