#include <windows.h>
#include <stdlib.h>

#include "defines.h"
#include "events.h"
#include "CPlayer.h"
#include "CMap.h"

CPlayer::CPlayer()
{
}

CPlayer::CPlayer(int xp,int yp,CMap* m)
{
	x = xp;
	y = yp;
	Px = 0;
	Py = 0;
	Y1 = 0;
	Y2 = 0;
	Y3 = 0;
	Y4 = 0;
	Y5 = 0;
	dir = 4;
	anim = 0;
	k = 0;
	lives = 3;
	power = BOMB_FIRST_POWER;
	pressLeft = false;
	pressRight = false;
	pressUp = false;
	pressDown = false;
	pressPut = false;
	pressExplode = false;
	timer = 0;
	die = false;
	blink = false;
	tBlink = 0;
	tDie = 0;
	tAnim = PLAYER_ANIM_SPEED;
	Nbombs = 1;
	Abombs = 0;
	map = new CMapAccess(m);
	for(int i=0;i<MAX_PLAYER_BOMBS;i++) bombs[i] = 0;
}

CPlayer::~CPlayer()
{
	delete map;
	map = 0;
	for(int i=0;i<MAX_PLAYER_BOMBS;i++) 
		if (bombs[i] != 0) 
		{
			delete bombs[i];
			bombs[i] = 0;
		}
}



void CPlayer::You()
{
	CEvent *e = new CEvent(ePLAYER_YOU);
	A1(e);
	delete e;
}

bool CPlayer::TranslateEvent(CEvent *e)
{
	A1(e);
	return true;
}

void CPlayer::Paint(int z)
{
	CEvent *e = new CEvent(ePLAYER_PAINT,(int)z);
	A1(e);
	delete e;
}

int CPlayer::placeNewBomb()
{
	if (map->checkMapPos(x,y) == 0)
	{
		int i = 0;
		while(i<MAX_PLAYER_BOMBS && bombs[i] != 0) i++;
		if (i<MAX_PLAYER_BOMBS)
		{
			bombs[i] = new CBomb(map,this,x,y,power);
			Abombs++;
			map->setMapPos(x,y,MAP_BOMB);
		}
	}
	return Abombs;
}

void CPlayer::deleteBomb(int n)
{
	if (n>=0 && n<MAX_PLAYER_BOMBS && bombs[n] != 0)
	{
		map->setMapPos(bombs[n]->x,bombs[n]->y,MAP_CLEAR);
		delete bombs[n];
		bombs[n] = 0;
	}
}

bool CPlayer::CheckBombExplosion(CBomb* bomb)
{
	int xb = bomb->x;
	int yb = bomb->y;
	int pb = bomb->power;
	bool lt = true;	bool rt = true;	bool up = true;	bool dn = true;
	bool hit = false;
	for(int i=1;i<=pb;i++)
	{	
		if (map->checkMapPos(xb + i,yb)>=3) rt = false;
		if (map->checkMapPos(xb - i,yb)>=3) lt = false;
		if (map->checkMapPos(xb,yb - i)>=3) up = false;
		if (map->checkMapPos(xb,yb + i)>=3) dn = false;
		
		if (dn && (xb == x && yb + i == y))	hit = true;
		if (rt && (xb + i == x && yb == y)) hit = true;
		if (lt && (xb - i == x && yb == y)) hit = true;
		if (up && (xb == x && yb - i == y)) hit = true;
	}	
	return hit;
}

void CPlayer::SetButtons(long kl,long kr,long ku,long kd,long kp,long ke)
{
	keyLeft = kl;
	keyRight = kr;
	keyUp = ku;
	keyDown = kd;
	keyPut = kp;
	keyExplode = ke;
}

bool CPlayer::checkMap(int x,int y)
{
	int xp = CPlayer::x + x;
	int yp = CPlayer::y + y;
	if (xp>=0 && yp>=0 && xp<MAP_WIDTH && yp<MAP_HEIGHT)
		return map->checkMapPos(CPlayer::x + x, CPlayer::y + y) == 0;
	else 
		return false;
}

void CPlayer::checkMove()
{
	if (Px > CELL_SIZE/2)
	{
		x++;
		Px -= CELL_SIZE;
	}
	if (Py > CELL_SIZE/2)
	{
		y++;
		Py -= CELL_SIZE;
	}
	if (Px < -CELL_SIZE/2)
	{
		x--;
		Px += CELL_SIZE;
	}
	if (Py < -CELL_SIZE/2)
	{
		y--;
		Py += CELL_SIZE;
	}
}

int CPlayer::getDir()
{
	if (Y3 == 0) 
		return dir;
	else 
		return Y3;
}

